// C Source File
// Created 06.03.2008; 16:07:02

#include "standart.h"

void AddExtension(l_file_p f, const char *e) {
	lputc(0, f);
	lputs(e, f);
	lputc(0, f);
	lputc(OTH_TAG, f);
	//lclose(f);
}

unsigned char LoadGameData(void) {
	
	//	unarchive save file
	UnArchive(SAVE_FILE_NAME);
	
	void *ptr = NULL;
	
	if(!(ptr = GetDataPtr(SAVE_FILE_NAME, 0))) {
		l_file_p file;
		char ok;
		
		//create file, size + extension
		if(!(file = lcreate(SAVE_FILE_NAME, SAVE_FILE_SIZE+((unsigned short)strlen(SAVE_FILE_EXT))+3, &ok))) {
			return 0;
		}
		
		unsigned char i;
		for(i = 0; i < MAX_HISCORES; ++i) {
			lwrite(&(HISCORE){"None", 0}, sizeof(HISCORE), file);
		}
		
		delay = 500;
		game_mode = G_RANDOM;
		
		lwrite(&delay, sizeof(delay), file);
		lwrite(&game_mode, sizeof(game_mode), file);
		
		AddExtension(file, SAVE_FILE_EXT);
		lclose(file);
		
		if(!(ptr = GetDataPtr(SAVE_FILE_NAME, 0))) {
			return 0;
		}
	}
	
	hiscore = (HISCORE *) ptr;
	
	ptr += MAX_HISCORES * sizeof(HISCORE);
	
	delay 		= *(unsigned short *)ptr;
	game_mode = *(unsigned char *)(ptr + sizeof(delay));
	
	return 1;
}

unsigned char SaveGameData(void) {
	void *ptr = NULL;
	
	if(!(ptr = GetDataPtr(SAVE_FILE_NAME, MAX_HISCORES * sizeof(HISCORE)))) {
		return 0;
	}
	
	*(unsigned short *)ptr = delay;
	*(unsigned char *)(ptr + sizeof(delay)) = game_mode;
	
	#ifndef DEBUG
		Archive(SAVE_FILE_NAME);
	#endif
	
	return 1;
}

void Archive(const char *Filename) {
	SYM_ENTRY *SymPtr = NULL;
	HSym hsym = SymFind(SYMSTR(Filename));
	
	SymPtr = DerefSym (hsym);
	
	if (EM_findEmptySlot(*GetDataPtr(Filename, -2)) == NULL)
		return;  // Make sure Garbage Collection will not occur
	if (!SymPtr->flags.bits.archived)
		EM_moveSymToExtMem(SYMSTR(Filename), HS_NULL);
}

void UnArchive(const char *Filename) {
	SYM_ENTRY *SymPtr = NULL;
	HSym hsym = SymFind(SYMSTR(Filename));
	
	SymPtr = DerefSym (hsym);
	
	if (SymPtr->flags.bits.archived)
		EM_moveSymFromExtMem(SYMSTR(Filename), HS_NULL);
}

unsigned char *GetDataPtr(const char *Filename, short Offset) {
	unsigned char *Location;
	SYM_ENTRY *SymPtr;
	
	if ((SymPtr = SymFindPtr(SYMSTR(Filename), 0)) == NULL)
		return NULL;  // File not found
	
	if ((Location = (unsigned char*) HeapDeref(SymPtr->handle)) == NULL)
		return NULL;
	return (Location + 2 + Offset);
}