// C Source File
// Created 04.03.2008; 15:21:49

#include "standart.h"

void InitStatusBar() {
	DecompressRLEHorz(status_bar1, 
		status_bar, STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT);
	DecompressRLEHorz(status_bar2, 
		status_bar + STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT,  STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT);
	//memcpy(status_bar, status_bar1, STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT);
	//memcpy(status_bar + STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT, status_bar2, STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT);
}

void DrawStatusBar() {
	memcpy(LightBuffer, 
		status_bar, STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT);
	memcpy(DarkBuffer, 
		status_bar + STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT, STATUS_BAR_BYTE_WIDTH * STATUS_BAR_HEIGHT);
}

inline void Display(void) {
	FastCopyScreen_R(LightBuffer, LightPlane);
	FastCopyScreen_R(DarkBuffer, DarkPlane);
}

/*inline unsigned char Collide(short x0, short y0, unsigned char w0, unsigned char h0, short x1, short y1, unsigned char w1, unsigned char h1) {
	return (((x1>=x0&&x1<x0+w0)||(x1+w1>=x0&&x1+w1<x0+w0))&&((y1>=y0&&y1<y0+h0)||(y1+h1>=y0&&y1+h1<y0+h0)));
}*/

void DrawSprite(short x, short y, const SPRITE *sprt) {
	
	x >>= COORD_SHIFT;
	y >>= COORD_SHIFT;
	
	//choose fitting function
	if(sprt->byte_width == 1) {
		GrayClipSprite8_MASK_R(x, y, sprt->height, 
									sprt->data, 
									sprt->data+  sprt->height, 
									sprt->data+2*sprt->height, 
									sprt->data+2*sprt->height, 
									LightBuffer, 
									DarkBuffer
		);
	} else if(sprt->byte_width == 2) {
		GrayClipSprite16_MASK_R(x, y, sprt->height, 
									sprt->data, 
									sprt->data+  2*sprt->height, 
									sprt->data+2*2*sprt->height, 
									sprt->data+2*2*sprt->height, 
									LightBuffer, 
									DarkBuffer
		);
	} else if(sprt->byte_width == 4) {
		GrayClipSprite32_MASK_R(x, y, sprt->height, 
									sprt->data, 
									sprt->data+  4*sprt->height, 
									sprt->data+2*4*sprt->height, 
									sprt->data+2*4*sprt->height, 
									LightBuffer, 
									DarkBuffer
		);
	}
	#ifdef DEBUG
		else {
			GrayDrawStrExt2B(0, 56, "Sprite of unsupported width!", A_REPLACE|A_SHADOWED|A_CENTERED, F_4x6, LightPlane, DarkPlane);
			WaitKey();
		}
	#endif
}

void DrawAnimatedSprite(short x, short y, const SPRITE *anim, unsigned char step) {
	
	x >>= COORD_SHIFT;
	y >>= COORD_SHIFT;
	
	//choose fitting function
	if(anim->byte_width == 1) {
		GrayClipSprite8_MASK_R(x, y, anim->height, 
									anim->data+(step*3+0)*anim->height, 
									anim->data+(step*3+1)*anim->height, 
									anim->data+(step*3+2)*anim->height, 
									anim->data+(step*3+2)*anim->height, 
									LightBuffer, 
									DarkBuffer
		);
	} else if(anim->byte_width == 2) {
		GrayClipSprite16_MASK_R(x, y, anim->height, 
									anim->data+(step*3+0)*2*anim->height, 
									anim->data+(step*3+1)*2*anim->height, 
									anim->data+(step*3+2)*2*anim->height, 
									anim->data+(step*3+2)*2*anim->height, 
									LightBuffer, 
									DarkBuffer
		);
	} else if(anim->byte_width == 4) {
		GrayClipSprite32_MASK_R(x, y, anim->height, 
									anim->data+(step*3+0)*4*anim->height, 
									anim->data+(step*3+1)*4*anim->height, 
									anim->data+(step*3+2)*4*anim->height, 
									anim->data+(step*3+2)*4*anim->height, 
									LightBuffer, 
									DarkBuffer
		);
	}
	#ifdef COUT_MSG
		else {
			GrayDrawStrExt2B(0, 56, "Sprite of unsupported width!", A_REPLACE|A_SHADOWED|A_CENTERED, F_4x6, LightPlane, DarkPlane);
			WaitKey();
		}
	#endif
}

void DrawHUD() {
	//	todo: faster
	static char money_[7], goal_[7], minutes_[3], seconds_[3], level_[3];
	
	if(update.money) {
		update.money = 0;
		itoa_ulong_10_extended(money_, money, 6, 1);
	}
	if(update.goal) {
		update.goal = 0;
		itoa_ulong_10_extended(goal_, goal, 6, 1);
	}
	if(update.minutes) {
		update.minutes = 0;
		itoa_ushort_10_extended(minutes_, clock.minutes, 2, 1);
	}
	if(update.seconds) {
		update.seconds = 0;
		itoa_ushort_10_extended(seconds_, clock.seconds, 2, 1);
	}
	if(update.level) {
		update.level = 0;
		itoa_ushort_10_extended(level_, lvlnum + 1, 2, 1);
	}
	
	FS_GrayDrawString(  3, 4, "Money:",   A_NORMAL|A_SHADOWED, F_4x6);
	FS_GrayDrawString(  3,10, money_,   A_NORMAL|A_SHADOWED, F_4x6);
	
	FS_GrayDrawString( 33, 4, "Goal:",    A_NORMAL|A_SHADOWED, F_4x6);
	FS_GrayDrawString( 33,10, goal_,    A_NORMAL|A_SHADOWED, F_4x6);
	
	FS_GrayDrawString( 61, 4, "Time:", A_NORMAL|A_SHADOWED, F_4x6);
	FS_GrayDrawString( 61,10, minutes_, A_NORMAL|A_SHADOWED, F_4x6);
	FS_GrayDrawString( 69,10, ":", A_NORMAL|A_SHADOWED, F_4x6);
	FS_GrayDrawString( 71,10, seconds_, A_NORMAL|A_SHADOWED, F_4x6);
	
	FS_GrayDrawString(215, 4, "Level:",   A_NORMAL|A_SHADOWED, F_4x6);
	FS_GrayDrawString(215,10, level_,   A_NORMAL|A_SHADOWED, F_4x6);
	
	//sprintf(buf_str, "Money: %lu, Goal: %lu, Time: %u:%u, Level: %u", money, goal, clock.minutes, clock.seconds, lvlnum+1);
	//FS_GrayDrawString(0, 0, buf_str, A_REPLACE|A_SHADOWED|A_CENTERED, F_4x6);
	
	
	//	draw available dynamites
	unsigned char i;
	for(i = 0; i < (winch.power_ups & 0b00001111)/*dynamites*/; ++i) {
		DrawSprite(dynamite_default_coords[0]+
							(5 << COORD_SHIFT) * i,
							dynamite_default_coords[1],
							&dynamite_sprts[0]);
	}
}