// C Source File
// Created 20.02.2008; 18:10:33

#include "standart.h"

//horizontal
/*void DecompRLEHorz(const unsigned char *input, unsigned char *output, unsigned short length)
{
   signed char count;
   while (length > 0) {
      count = (signed char)*input++;
      if (count > 0) {
         memset(output,*input++,count);
      } else if (count < 0) {
         count = (signed char)-count;
         memcpy(output,input,count);
         input += count;
      }
      output += count;
      length -= count;
   }
}*/

void DecompressRLEHorz(const unsigned char *Src, unsigned char *Dest, unsigned short Size) {
	register unsigned char a;
	// RLE = Flag (0x91), Value, Number of Repititions
	
	while (Size > 0) {
		// Decompress one run
		if (*Src == 0x91) {
			Src++;
			for(a = *(Src + 1); a--;)
				*Dest++ = *Src;
			Size -= *(++Src);
		} else if (*Src == 0x92) {
			Src++;
			for(a = 0; a < *(Src + 1); a++)
				*Dest++ = (*Src) + a;
			Size -= *(++Src);
		} else {
			*Dest++ = *Src;
			Size--;
		}
		Src++;
	}
}


//vertical
#define SENTINEL_VALUE 0x91

void DecompRLEVert(const unsigned char *src, unsigned char *dest, unsigned short cols, unsigned short rows) {
	unsigned short i = 0, j;
	unsigned short pos = 0;
	unsigned short dcmpNum = 0;
	
	while (dcmpNum < cols * rows)
	{
		//decompress a run
		if (src[i] == SENTINEL_VALUE)
		{
			i++;
			for(j = 0; j < src[i + 1]; j++)
			{
				dest[pos] = src[i];
				pos += cols;
				if (pos >= cols * rows)
				{
					pos -= cols * rows;
					pos++;
				}
			}
			i++;
			dcmpNum += src[i];
		}
		else
		{
			dest[pos] = src[i];
			pos += cols;
			if (pos >= cols * rows)
			{
				pos -= cols * rows;
				pos++;
			}
			dcmpNum++;
		}
		i++;
	}
}

// dissolves a picture to the screen (orginally by TICT)
void Dissolve(char *dplane, char *lplane, char *buff1, char *buff2)
{
	unsigned short  seq = 1;
	unsigned char   pixmask;
	unsigned short  byteoffset;

	do {
		pixmask    = seq & 0x7;
		byteoffset = seq >> 3;

        if (byteoffset < LCD_SIZE) {
            pixmask = 0x80 >> pixmask;

            //-------------------------------------
            // Copy light plane
            //-------------------------------------
        	if (*(unsigned char *)(buff2+byteoffset) & pixmask) {
           	    *(unsigned char *)(lplane+byteoffset) |= pixmask;
            }
        	else {
          	    *(unsigned char *)(lplane+byteoffset) &= ~pixmask;
           }

            //-------------------------------------
            // Copy dark plane
            //-------------------------------------
        	if (*(unsigned char *)(buff1+byteoffset) & pixmask) {
           	    *(unsigned char *)(dplane+byteoffset) |= pixmask;
         	}
        	else {
          	    *(unsigned char *)(dplane+byteoffset) &= ~pixmask;
            }

        }

        if (seq & 1) seq = (seq>>1)^0x6000;
        else         seq = seq>>1;
    }
    while (seq != 1);
}
