// C Source File
// Created 05.03.2008; 15:34:18

#include "standart.h"

/*
1126

90,0,0,0,376 - 2303
230,0,0,48,0 - 3486
28,224,0,23,0 - 5222
273,0,0,143,0 - 6966
23,0,0,0,710 - 7222
153,171,0,0,687 - 10000
60,280,0,4,0 - 
0,0,116,0,1066 - 
0,132,0,0,496 - 
*/

/*"Click on the items you want to buy. Click
on 'Next Level' when you are ready to go on."*/

//enum ShopItems {S_DYNAMITE, S_STRENGTH_DRINK, S_LUCKY_CLOVER, S_ROCK_BOOK, S_DIAMOND_POLISH};

#define SHOP_ITEM_NR	5
const unsigned short price_factors[SHOP_ITEM_NR] = {
	13,6,4,8,10
};

const unsigned char item_widths[SHOP_ITEM_NR] = {
	16, 30, 18, 30, 20,
};

const unsigned char *shop_texts[SHOP_ITEM_NR << 1] = {
	"After you have grabbed onto something with your claw, press",
	"'Hand' to throw a piece of dynamite at it and blow it up.",
	
	"Strength drink. The miner will reel up objects a little faster",
	"on the next level. The drink only lasts for one level.",
	
	//	Lucky Clover. 
	"This will increase the chances of getting something good out of",
	"the grab bags on the next level. This is only good for one level.",
	
	"Rock Collectors book. Rocks will be worth three times as",
	"much money on the next level. This is only good for one level.",
	
	"Diamond Polish. During the next level diamonds",
	"will be worth more money. Only good for one level.",
};


const unsigned char *shop_item_sprts[SHOP_ITEM_NR] = {
	_s_dynamite,
	_s_strength_drink,
	_s_lucky_clover,
	_s_rock_book,
	_s_diamond_polish,
};

void Shop() {
	unsigned char exit = 0, cursor = 0, i, x;
	unsigned char active[SHOP_ITEM_NR] = {1,1,1,1,1};
	unsigned short prices[SHOP_ITEM_NR];
	for(i = 0; i < SHOP_ITEM_NR; ++i) {
		prices[i] = (unsigned short)(money / (unsigned long)price_factors[i]);
	}
	do {
		FastFillScreen_R(LightBuffer);
		FastFillScreen_R(DarkBuffer);
		GrayFastFillRect_R(LightBuffer,DarkBuffer,10,8,LCD_WIDTH-1-10,LCD_HEIGHT-1-8,COLOR_WHITE);
		
		//FS_GrayDrawString(0,16,"Shop",A_NORMAL|A_CENTERED|A_SHADOWED,F_8x10);
		
		//	draw title
		SpriteX8_MASK_R((LCD_WIDTH - (TITLE_BYTE_WIDTH << 3)) >> 1,
			10,TITLE_HEIGHT,
			_title_l,_title_m,
			TITLE_BYTE_WIDTH,
			LightBuffer);
		SpriteX8_MASK_R((LCD_WIDTH - (TITLE_BYTE_WIDTH << 3)) >> 1,
			10,TITLE_HEIGHT,
			_title_d,_title_m,
			TITLE_BYTE_WIDTH,
			DarkBuffer);
		
		//	draw item picture
		/*SpriteX8_OR_R((LCD_WIDTH - (ITEM_PIC_BYTE_WIDTH << 3)) >> 1,
			40,ITEM_PIC_HEIGHT,
			shop_items_sprt,
			ITEM_PIC_BYTE_WIDTH,
			LightBuffer);
		SpriteX8_OR_R((LCD_WIDTH - (ITEM_PIC_BYTE_WIDTH << 3)) >> 1,
			40,ITEM_PIC_HEIGHT,
			shop_items_sprt + ITEM_PIC_BYTE_WIDTH * ITEM_PIC_HEIGHT,
			ITEM_PIC_BYTE_WIDTH,
			DarkBuffer);*/
		
		//	draw information
		itoa_ulong_10_extended(buf_str, money, 6, 1);
		FS_GrayDrawString(190,30,"Money:",A_NORMAL|A_SHADOWED,F_4x6);
		FS_GrayDrawString(190,40,buf_str,A_NORMAL|A_SHADOWED,F_4x6);
		
		FS_GrayDrawString(190,60,"Hand - Buy",A_NORMAL|A_SHADOWED,F_4x6);
		FS_GrayDrawString(190,70,"Esc - Exit",A_NORMAL|A_SHADOWED,F_4x6);
		
		FS_GrayDrawString(10,100,shop_texts[cursor << 1],A_NORMAL|A_CENTERED|A_SHADOWED,F_4x6);
		FS_GrayDrawString(10,110,shop_texts[(cursor << 1) + 1],A_NORMAL|A_CENTERED|A_SHADOWED,F_4x6);
		
		x = 30;
		for(i = 0; i < SHOP_ITEM_NR; ++i) {
			if(active[i]) {
				//	draw item
				GraySprite32_OR_R(x,40,
					ITEM_PIC_HEIGHT,
					(unsigned long *)shop_item_sprts[i],
					(unsigned long *)(shop_item_sprts[i]+(ITEM_PIC_HEIGHT << 2)),
					LightBuffer,DarkBuffer);
				
				//	draw price
				itoa_ushort_10(buf_str,prices[i]);
				FS_GrayDrawString(x,76,buf_str,A_NORMAL|A_SHADOWED,F_4x6);
			}
			x += item_widths[i] + 8;
		}
		
		Display();
		
		//	draw cursor
		x = 30 + (item_widths[0] >> 1);
		for(i = 0; i < cursor; ++i) {
			x += item_widths[i] + 8;
		}
		GraySprite8_OR_R(x,86,8,_cursor_up,_cursor_up+8,LightPlane,DarkPlane);
		
		while(_rowread(0)) {
			HandleTeacherKeys();
		}
		if(Error != ERR_NONE) {
			break;
		}
		while(!_rowread(0));
		
		if(_keytest(RR_LEFT)) {
			if(cursor) {
				--cursor;
			} else {
				cursor = SHOP_ITEM_NR-1;
			}
		}
		if(_keytest(RR_RIGHT)) {
			if(cursor < SHOP_ITEM_NR-1) {
				++cursor;
			} else {
				cursor = 0;
			}
		}
		if(_keytest(RR_MINUS)) {
			OSContrastDn();
		} 
		if(_keytest(RR_PLUS)) {
			OSContrastUp();
		}
		if(_keytest(RR_ESC)) {
			exit = 1;
		}
		if(_keytest(RR_ENTER) || _keytest(RR_ENTER2) || _keytest(RR_HAND)) {
			
			//	buy
			if(active[cursor] && money >= money / price_factors[cursor]) {
				if(cursor == P_DYNAMITE	/*S_DYNAMITE*/) {
					if((winch.power_ups & 0b00001111) < MAX_DYNAMITES) {
						money -= prices[cursor];
						active[cursor] = 0;
						++winch.power_ups;
					}
				} else {
					money -= prices[cursor];
					active[cursor] = 0;
					winch.power_ups |= 1 << (8 - cursor);
				}
				#ifdef DEBUG
					sprintf(buf_str, "%u", winch.power_ups);
					GrayDrawStrExt2B(0,32,buf_str,A_NORMAL|A_CENTERED,F_8x10,LightPlane,DarkPlane);
					WaitKey();
				#endif
			}
		}
		
		//WaitKey();
	} while(!exit /*&& Error == ERR_NONE*/);
	while(_rowread(0));
}